#ifndef _ODAI_SERVER_H_
#define _ODAI_SERVER_H_

#include <odai/snl.h>
#include <odai/clients.h>
#include <odai/functions.h>
#include <odai/mutex.h>

class Server {

public:

	Server(const char *name, unsigned short port);

	int msg(const char *fmt, ...);
	int reg(const char *fmt, void *fn);

private:

	Functions functions;
	Clients   clients;
	Mutex     mutex;

	static SNL_LISTEN_CALLBACK(listen_callback);
	static SNL_READ_CALLBACK(read_callback);

};

#endif
