#include <unistd.h>

#include "snl.h"

#include "clients.h"

Clients::~Clients() {
	list<int>::iterator client;

	client = l.begin(); 
	while (client != l.end()) {
		// XXX maybe we should inform client first? :o)
		close(*client);
		l.erase(client); 
		client++;
	}
}

void
Clients::add(int fd) {
	l.push_back(fd);
}

void
Clients::remove(int fd) {
	list<int>::iterator client;

	client = l.begin();
	while (client != l.end()) {
		if (*client == fd) {
			l.erase(client);
			break;
		}
		client++;
	}
}

void
Clients::broadcast(void *buf, int size) {
	list<int>::iterator client;

	client = l.begin();
	while (client != l.end()) {
		snl_write(*client, buf, size);
		usleep(1);
		client++;
	}
}
