#include "parser.h"

static void
clean(string &in) {
	string out;

	for (int i=0; i<(int)in.length(); i++) {
		if ((in[i]!=',') && (in[i]!=' ') && (in[i]!='(') && (in[i]!=')')) {
			out += in[i];
		}
	}
	in = out;
}

bool
split(const string fmt, string &ret, string &fnc, string &par) {
	int x, y, z;

	x = fmt.find(' '); y = fmt.find('('); z = fmt.find(')');
	if ((x >= y) || (x == -1) || (y == -1) || (z == -1)) {
		return (true);
	}
	ret = fmt.substr(0, x);
	fnc = fmt.substr(x, y);
	par = fmt.substr(y, z);
	clean(ret);
	clean(fnc);
	clean(par);
	return (false);
}
